/*
Flashing led demo using interrupts
PIC32MX220F032B on ORbit16
By Bernardo Giovanni
www.settorezero.com
www.orbit16.com
*/

#include <p32xxxx.h>
#include <plib.h>
#include "config_word_pic32.h"
#define LEDTOGGLE	LATBINV=1<<5; // macro for inverting the status of RB5

// led will stay 500mS on and 500mS off
int ledcount=500;

main(void)
	{
	ANSELA=0x0000;
    ANSELB=0x0000;
	TRISBCLR=1<<5; // RB5 as output (led)
	TRISBSET=1<<7; // RB7 as input (button)
	SYSTEMConfigPerformance(40000000ul);
	
	// Peripheral runs at 40MHz since FPBDIV=1 (period=25nS)
	// Set Timer1 with prescaler 1:8 and period=5000
	// 25ns * 8 * 5000 = 1ms
	// Timer1 interrupt will fire every 1mS
	OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_8, 5000-1);
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_1); // T1 interrupt ON, Priority 1
    INTEnableSystemMultiVectoredInt(); // enable multi-vectored interrupts
    	
	while(1)
		{
		continue;
		}
	} // main

// Timer1 interrupt vector. IPL must be the same as defined in confingtimer1 function
void __ISR(_TIMER_1_VECTOR, ipl1) T1InterruptHandler(void)
	{
	ledcount--;
	if (ledcount<0)
		{
		ledcount=500;
		LEDTOGGLE;
		}
	 mT1ClearIntFlag(); // clear T1 interrupt flag
	}